/*=================================================================================
	ocomp.c
-----------------------------------------------------------------------------------
	AEgvbgERyAgLED_łvO
		OC1F7ʂ̖邳LED_
		OC4Fǔ̂悤ɓ_ł
		OC8FONOFFJԂē_ł

	NbN\[X	Fosc = 7.37[MHz] :dsPIC̓NbNgp
	VXeNbNFsy  = 7.37 * 8 = 58.96[MHz] :PLLx8gp
	߃NbN	Fcy  = 58.96 / 4 = 14.74[MHz]
=================================================================================*/
#include <p30f5011.h>	//TRISB̓@\WX^gp邽߂ɌĂяo
#include "lcd.h"		//LCDp֐̃vg^Cv錾

//Configuration bits (dsPIC̊{ݒ)----------------------------------------------
_FOSC(CSW_FSCM_OFF & FRC_PLL8);		//RCiNbNj8{, NbNj^[OFF
_FWDT(WDT_OFF);						//EHb`hbO^C}[OFF
_FBORPOR(PBOR_OFF & MCLR_EN);		//uEAEgZbgOFF, }X^[NAL
_FGS(CODE_PROT_OFF);				//R[hیOFF
//----------------------------------------------------------------------------------------
#define NULL 0x00	//NULL0x00Ƃ

int val=1;			//duty 3%
int duty = 1;		//duty 1%
char lcddata[9];	//LCDpf[^z

int main(void)
{
	int i;

	TRISB = 0xffc0;		//RB5-RB0:o
	TRISD = 0xff00;		//RD7-RD0:o,RD11-RD8:

	SR = ((SR & 0xff1f) | 0x0020);	//MPU荞ݗDx1ɐݒ
	INTCON1 = 0x8000;				//d荞݋֎~
	INTCON2 = 0x0000;				//IVTgpAINT1̊荞݂͗オGbWƂ
	IPC4 = ((IPC4 & 0xfff8) | 0x0005);	//INT1荞ݗDx5ɐݒ
	IFS1 = (IFS1 & 0xfffe);			//INT1荞݃tONA
	IEC1 = ((IEC1 & 0xfffe) | 0x0001);	//INT1荞݋,RD8sINT1ɂȂ

	OC1R = 0x01ff;		//duty 1%
	OC1RS = 0x01ff;		//duty 1%
	OC1CON = 0x0006;	//PWM[h,^C}2gp

	OC4R = 0xffff;
	OC4RS = 0xffff;
	OC4CON = 0x0006;	//PWM[h,^C}2gp

	OC8R = 0xffff;		//0xffff->4.4ms, 4.4ms*64{ = 281.6ms
	OC8CON = 0x000b;	//Vvo͔rv[h,^C}3gp

	PR2 = 0xffff;		//PWM̎ 0xffff->4.4ms
	T2CON = 0x8000;		//^C}2 ON

	PR3 = 0xffff;		//0xffff->4.4ms, 4.4ms*64{ = 281.6ms
	T3CON = 0x8020;		//^C}3 ON,vXP[l 64

	InitLCD();						//LCD
	PrintLCD("Simple PWM mode\n");	//LCD1sڂɕ\ĉs
	lcddata[0] = 'd';
	lcddata[1] = 'u';
	lcddata[2] = 't';
	lcddata[3] = 'y';
	lcddata[4] = '=';
	lcddata[5] = '0' + duty % 100 / 10;		//10i2
	lcddata[6] = '0' + duty % 10;			//10i1
	lcddata[7] = '%';
	lcddata[8] = NULL;				//̏I
	PrintLCD(lcddata);				//LCDlcddata̓e\

	while(1){
		for(i=0;i<16;i++){			//duty 100%() --> duty 0%()
			OC4RS = (0xffff>>i);	//EVtg
			wait(100);				//100ms҂
		}
		for(i=14;i>0;i--){			//duty 0%() --> duty 100%()
			OC4RS = (0xffff>>i);	//EVtg
			wait(100);				//100ms҂
		}
	}
	return 0;
}

void __attribute__((interrupt)) _INT1Interrupt(void)
{
	int buff[5]={0,0,0,0,0};	//buffFINT1̓͒lz

	//ȈՃ`^O΍
	while(1){
		buff[4] = buff[3];	//INT1̓͒lVtg
		buff[3] = buff[2];	//buff[4]=>ŏ̓͒l,buff[0]=>Ō̓͒l
		buff[2] = buff[1];
		buff[1] = buff[0];
		buff[0] = (PORTD & 0x0100);	//RD8(INT1)ȊO}XN
		//5'H'xoA[v𔲂B
		if(buff[0]&buff[1]&buff[2]&buff[3]&buff[4]) break;
		wait(1);	//1ms҂
	}

	IFS1 = (IFS1 & 0xfffe);			//INT1荞݃tONA

	switch(val){					//_LEDVtgx̕ύX
		case 0:		OC1RS = 0x01ff;	//duty=1%
					duty = 1;
					val++;
					break;
		case 1:		OC1RS = 0x07ff;	//duty=3%
					duty = 3;
					val++;
					break;
		case 2:		OC1RS = 0x0fff;	//duty=6%
					duty = 6;
					val++;
					break;
		case 3:		OC1RS = 0x1fff;	//duty=13%
					duty = 13;
					val++;
					break;
		case 4:		OC1RS = 0x3fff;	//duty=25%
					duty = 25;
					val++;
					break;
		case 5:		OC1RS = 0x7fff;	//duty=50%
					duty = 50;
					val++;
					break;
		case 6:		OC1RS = 0xf000;	//duty=94%
					duty = 94;
					val=0;
					break;
		default:	OC1RS = 0xffff;
					val=0;
					break;
	}

	//LCD\XV
	lcddata[5] = '0' + duty % 100 / 10;		//10i2
	lcddata[6] = '0' + duty % 10;			//10i1
	LocateLCD(0,1);					//LCD2sڂ̐擪ɃJ[\߂
	PrintLCD(lcddata);				//LCDlcddata̓e\
}
